use std::collections::VecDeque;

/// Increments count if each sample is larger than the previous.
pub fn part1(input: String) {
    let mut prev = None;
    let mut count: u32 = 0;
    for line in input.lines() {
        let cur = str::parse::<i64>(line).unwrap();

        if let Some(prev) = prev {
            if cur > prev {
                count += 1;
            }
        }

        prev = Some(cur);
    }

    println!("{}", count);
}

/// 3-sample windowing average (no need to average, just use sum here)
///
/// We need to start comparing when we have all of
pub fn part2(input: String) {
    let mut storage = VecDeque::with_capacity(5);
    let mut count = 0;

    for line in input.lines() {
        let cur = str::parse::<i64>(line).unwrap();

        storage.push_back(cur);

        if storage.len() == 4 {
            let prev_window: i64 = storage.iter().take(3).sum();
            let cur_window: i64 = storage.iter().skip(1).take(3).sum();

            if cur_window > prev_window {
                count += 1;
            }

            storage.pop_front();
        }
    }

    println!("{}", count);
}
