struct Position {
    pub x: i64,
    #[allow(dead_code)]
    pub y: i64,
    pub z: i64,
}

impl std::default::Default for Position {
    fn default() -> Self {
        Self { x: 0, y: 0, z: 0 }
    }
}

pub fn part1(input: String) {
    let mut pos = Position::default();

    for line in input.lines() {
        let mut command = line.split(' ');
        let dir = command.next().unwrap();
        let distance = command.next().unwrap().parse::<i64>().unwrap();

        match dir {
            "forward" => pos.x += distance,
            "up" => pos.z += distance,
            "down" => pos.z -= distance,
            _ => panic!("Invalid input!"),
        }
    }

    println!("{}", pos.x * -pos.z);
}

pub fn part2(input: String) {
    let mut pos = Position::default();
    let mut attitude = 0i64;

    for line in input.lines() {
        let mut command = line.split(' ');
        let dir = command.next().unwrap();
        let distance = command.next().unwrap().parse::<i64>().unwrap();

        match dir {
            "forward" => {
                pos.x += distance;
                pos.z += distance * attitude;
            }
            "up" => attitude += distance,
            "down" => attitude -= distance,
            _ => panic!("Invalid input!"),
        }
    }

    println!("{}", pos.x * -pos.z);
}
